Zip (Apache Ant API)
Keywords: org.apache.tools.ant.taskdefs.Zip class

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.tools.ant.taskdefs
Class Zip

    java.lang.Object
      org.apache.tools.ant.ProjectComponent
          org.apache.tools.ant.Task
              org.apache.tools.ant.taskdefs.MatchingTask
                  org.apache.tools.ant.taskdefs.Zip

All Implemented Interfaces:
  SelectorContainer

Direct Known Subclasses:
  Jar

public class Zip
extends MatchingTask

Create a Zip file.

Since:
  Ant 1.1
Author:
  James Davidson duncan@x180.com, Jon S. Stevens jon@clearink.com, Stefan Bodewig, Antoine Levy-Lambert

Nested Class Summary
`static class` | `Zip.ArchiveState` Holds the up-to-date status and the out-of-date resources of the original archive.
`static class` | `Zip.Duplicate` Possible behaviors when a duplicate file is added: "add", "preserve" or "fail"
`static class` | `Zip.WhenEmpty` Possible behaviors when there are no matching files for the task: "fail", "skip", or "create".

Field Summary
`protected java.util.Hashtable` | `addedDirs`
`protected java.lang.String` | `archiveType`
`protected java.lang.String` | `duplicate`
`protected java.lang.String` | `emptyBehavior`
`protected java.util.Hashtable` | `entries`
`protected java.io.File` | `zipFile`

Fields inherited from class org.apache.tools.ant.taskdefs.MatchingTask
`fileset, useDefaultExcludes`

Fields inherited from class org.apache.tools.ant.Task
`description, location, target, taskName, taskType, wrapper`

Fields inherited from class org.apache.tools.ant.ProjectComponent
`project`

Constructor Summary
`Zip()`

Method Summary
`void` | `addFileset(FileSet set)` Adds a set of files.
`protected void` | `addParentDirs(java.io.File baseDir, java.lang.String entry, ZipOutputStream zOut, java.lang.String prefix, int dirMode)` Ensure all parent dirs of a given entry have been added.
`protected void` | `addResources(FileSet fileset, Resource[] resources, ZipOutputStream zOut)` Add the given resources.
`void` | `addZipfileset(ZipFileSet set)` Adds a set of files that can be read from an archive and be given a prefix/fullpath.
`void` | `addZipGroupFileset(FileSet set)` Adds a group of zip files.
`protected void` | `cleanUp()` Do any clean up necessary to allow this instance to be used again.
`protected boolean` | `createEmptyZip(java.io.File zipFile)` Create an empty zip file
`void` | `execute()` validate and build
`protected void` | `finalizeZipOutputStream(ZipOutputStream zOut)` method for subclasses to override
`java.io.File` | `getDestFile()` The file to create.
`java.lang.String` | `getEncoding()` Encoding to use for filenames.
`protected Zip.ArchiveState` | `getResourcesToAdd(FileSet[] filesets, java.io.File zipFile, boolean needsUpdate)` Collect the resources that are newer than the corresponding entries (or missing) in the original archive.
`protected Resource[][]` | `grabResources(FileSet[] filesets)` Fetch all included and not excluded resources from the sets.
`protected void` | `initZipOutputStream(ZipOutputStream zOut)` method for subclasses to override
`protected boolean` | `isAddingNewFiles()` Indicates if the task is adding new files into the archive as opposed to copying back unchanged files from the backup copy
`boolean` | `isCompress()` Whether we want to compress the files or only store them;
`protected static boolean` | `isEmpty(Resource[][] r)`
`boolean` | `isInUpdateMode()` Are we updating an existing archive?
`void` | `reset()` Makes this instance reset all attributes to their default values and forget all children.
`void` | `setBasedir(java.io.File baseDir)` Directory from which to archive files; optional.
`void` | `setCompress(boolean c)` Whether we want to compress the files or only store them; optional, default=true;
`void` | `setDestFile(java.io.File destFile)` The file to create; required.
`void` | `setDuplicate(Zip.Duplicate df)` Sets behavior for when a duplicate file is about to be added - one of `keep`, `skip` or `overwrite`.
`void` | `setEncoding(java.lang.String encoding)` Encoding to use for filenames, defaults to the platform's default encoding.
`void` | `setFile(java.io.File file)` Deprecated. Use setDestFile(File) instead
`void` | `setFilesonly(boolean f)` If true, emulate Sun's jar utility by not adding parent directories; optional, defaults to false.
`void` | `setUpdate(boolean c)` If true, updates an existing file, otherwise overwrite any existing one; optional defaults to false.
`void` | `setWhenempty(Zip.WhenEmpty we)` Sets behavior of the task when no files match.
`void` | `setZipfile(java.io.File zipFile)` Deprecated. Use setDestFile(File) instead.
`protected void` | `zipDir(java.io.File dir, ZipOutputStream zOut, java.lang.String vPath, int mode)`
`protected void` | `zipFile(java.io.File file, ZipOutputStream zOut, java.lang.String vPath, int mode)` Method that gets called when adding from java.io.File instances.
`protected void` | `zipFile(java.io.InputStream in, ZipOutputStream zOut, java.lang.String vPath, long lastModified, java.io.File fromArchive, int mode)` Adds a new entry to the archive, takes care of duplicates as well.

Methods inherited from class org.apache.tools.ant.taskdefs.MatchingTask
`addAnd, addContains, addCustom, addDate, addDepend, addDepth, addFilename, addMajority, addNone, addNot, addOr, addPresent, addSelector, addSize, appendSelector, createExclude, createExcludesFile, createInclude, createIncludesFile, createPatternSet, getDirectoryScanner, getImplicitFileSet, getSelectors, hasSelectors, selectorCount, selectorElements, setCaseSensitive, setDefaultexcludes, setExcludes, setExcludesfile, setFollowSymlinks, setIncludes, setIncludesfile, setProject, XsetIgnore, XsetItems`

Methods inherited from class org.apache.tools.ant.Task
`getDescription, getLocation, getOwningTarget, getRuntimeConfigurableWrapper, getTaskName, handleErrorFlush, handleErrorOutput, handleFlush, handleOutput, init, isInvalid, log, log, maybeConfigure, perform, setDescription, setLocation, setOwningTarget, setRuntimeConfigurableWrapper, setTaskName`

Methods inherited from class org.apache.tools.ant.ProjectComponent
`getProject`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### zipFile

    protected java.io.File zipFile

### entries

    protected java.util.Hashtable entries

### duplicate

    protected java.lang.String duplicate

### archiveType

    protected java.lang.String archiveType

### emptyBehavior

    protected java.lang.String emptyBehavior

### addedDirs

    protected java.util.Hashtable addedDirs

Constructor Detail

### Zip

    public Zip()

Method Detail

### setZipfile

    public void setZipfile(java.io.File zipFile)

  Deprecated. Use setDestFile(File) instead.

  This is the name/location of where to create the .zip file.

### setFile

    public void setFile(java.io.File file)

  Deprecated. Use setDestFile(File) instead

  This is the name/location of where to create the file.

  Since:
    Ant 1.5

### setDestFile

    public void setDestFile(java.io.File destFile)

  The file to create; required.

  Parameters:
    `destFile` - The new destination File
  Since:
    Ant 1.5

### getDestFile

    public java.io.File getDestFile()

  The file to create.

  Since:
    Ant 1.5.2

### setBasedir

    public void setBasedir(java.io.File baseDir)

  Directory from which to archive files; optional.

### setCompress

    public void setCompress(boolean c)

  Whether we want to compress the files or only store them; optional, default=true;

### isCompress

    public boolean isCompress()

  Whether we want to compress the files or only store them;

  Since:
    Ant 1.5.2

### setFilesonly

    public void setFilesonly(boolean f)

  If true, emulate Sun's jar utility by not adding parent directories; optional, defaults to false.

### setUpdate

    public void setUpdate(boolean c)

  If true, updates an existing file, otherwise overwrite any existing one; optional defaults to false.

### isInUpdateMode

    public boolean isInUpdateMode()

  Are we updating an existing archive?

### addFileset

    public void addFileset(FileSet set)

  Adds a set of files.

### addZipfileset

    public void addZipfileset(ZipFileSet set)

  Adds a set of files that can be read from an archive and be given a prefix/fullpath.

### addZipGroupFileset

    public void addZipGroupFileset(FileSet set)

  Adds a group of zip files.

### setDuplicate

    public void setDuplicate(Zip.Duplicate df)

  Sets behavior for when a duplicate file is about to be added - one of `keep`, `skip` or `overwrite`. Possible values are: `keep` (keep both of the files); `skip` (keep the first version of the file found); `overwrite` overwrite the file with the new file Default for zip tasks is `keep`

### setWhenempty

    public void setWhenempty(Zip.WhenEmpty we)

  Sets behavior of the task when no files match. Possible values are: `fail` (throw an exception and halt the build); `skip` (do not create any archive, but issue a warning); `create` (make an archive with no entries). Default for zip tasks is `skip`; for jar tasks, `create`.

### setEncoding

    public void setEncoding(java.lang.String encoding)

  Encoding to use for filenames, defaults to the platform's default encoding.

  For a list of possible values see http://java.sun.com/products/jdk/1.2/docs/guide/internat/encoding.doc.html.

### getEncoding

    public java.lang.String getEncoding()

  Encoding to use for filenames.

  Since:
    Ant 1.5.2

### execute

    public void execute()
                 throws BuildException

  validate and build

  Overrides:
    `execute` in class `Task`
  Throws:
    `BuildException` - if something goes wrong with the build

### isAddingNewFiles

    protected final boolean isAddingNewFiles()

  Indicates if the task is adding new files into the archive as opposed to copying back unchanged files from the backup copy

### addResources

    protected final void addResources(FileSet fileset,
                                      Resource[] resources,
                                      ZipOutputStream zOut)
                               throws java.io.IOException

  Add the given resources.

  Parameters:
    `fileset` - may give additional information like fullpath or permissions.
    `resources` - the resources to add
    `zOut` - the stream to write to
  Throws:
    `java.io.IOException`
  Since:
    Ant 1.5.2

### initZipOutputStream

    protected void initZipOutputStream(ZipOutputStream zOut)
                                throws java.io.IOException,
                                       BuildException

  method for subclasses to override

  Throws:
    `java.io.IOException`
    `BuildException`

### finalizeZipOutputStream

    protected void finalizeZipOutputStream(ZipOutputStream zOut)
                                    throws java.io.IOException,
                                           BuildException

  method for subclasses to override

  Throws:
    `java.io.IOException`
    `BuildException`

### createEmptyZip

    protected boolean createEmptyZip(java.io.File zipFile)
                              throws BuildException

  Create an empty zip file

  Returns:
    true for historic reasons
  Throws:
    `BuildException`

### getResourcesToAdd

    protected Zip.ArchiveState getResourcesToAdd(FileSet[] filesets,
                                                 java.io.File zipFile,
                                                 boolean needsUpdate)
                                          throws BuildException

  Collect the resources that are newer than the corresponding entries (or missing) in the original archive.

  If we are going to recreate the archive instead of updating it, all resources should be considered as new, if a single one is. Because of this, subclasses overriding this method must call `super.getResourcesToAdd` and indicate with the third arg if they already know that the archive is out-of-date.

  Parameters:
    `filesets` - The filesets to grab resources from
    `zipFile` - intended archive file (may or may not exist)
    `needsUpdate` - whether we already know that the archive is out-of-date. Subclasses overriding this method are supposed to set this value correctly in their call to super.getResourcesToAdd.
  Returns:
    an array of resources to add for each fileset passed in as well as a flag that indicates whether the archive is uptodate.
  Throws:
    `BuildException` - if it likes

### grabResources

    protected Resource[][] grabResources(FileSet[] filesets)

  Fetch all included and not excluded resources from the sets.

  Included directories will preceede included files.

  Since:
    Ant 1.5.2

### zipDir

    protected void zipDir(java.io.File dir,
                          ZipOutputStream zOut,
                          java.lang.String vPath,
                          int mode)
                   throws java.io.IOException

  Throws:
    `java.io.IOException`
  Since:
    Ant 1.5.2

### zipFile

    protected void zipFile(java.io.InputStream in,
                           ZipOutputStream zOut,
                           java.lang.String vPath,
                           long lastModified,
                           java.io.File fromArchive,
                           int mode)
                    throws java.io.IOException

  Adds a new entry to the archive, takes care of duplicates as well.

  Parameters:
    `in` - the stream to read data for the entry from.
    `zOut` - the stream to write to.
    `vPath` - the name this entry shall have in the archive.
    `lastModified` - last modification time for the entry.
    `fromArchive` - the original archive we are copying this entry from, will be null if we are not copying from an archive.
    `mode` - the Unix permissions to set.
  Throws:
    `java.io.IOException`
  Since:
    Ant 1.5.2

### zipFile

    protected void zipFile(java.io.File file,
                           ZipOutputStream zOut,
                           java.lang.String vPath,
                           int mode)
                    throws java.io.IOException

  Method that gets called when adding from java.io.File instances.

  This implementation delegates to the six-arg version.

  Parameters:
    `file` - the file to add to the archive
    `zOut` - the stream to write to
    `vPath` - the name this entry shall have in the archive
    `mode` - the Unix permissions to set.
  Throws:
    `java.io.IOException`
  Since:
    Ant 1.5.2

### addParentDirs

    protected final void addParentDirs(java.io.File baseDir,
                                       java.lang.String entry,
                                       ZipOutputStream zOut,
                                       java.lang.String prefix,
                                       int dirMode)
                                throws java.io.IOException

  Ensure all parent dirs of a given entry have been added.

  Throws:
    `java.io.IOException`
  Since:
    Ant 1.5.2

### cleanUp

    protected void cleanUp()

  Do any clean up necessary to allow this instance to be used again.

  When we get here, the Zip file has been closed and all we need to do is to reset some globals.

  This method will only reset globals that have been changed during execute(), it will not alter the attributes or nested child elements. If you want to reset the instance so that you can later zip a completely different set of files, you must use the reset method.

  See Also:
    `reset()`

### reset

    public void reset()

  Makes this instance reset all attributes to their default values and forget all children.

  Since:
    Ant 1.5
  See Also:
    `cleanUp()`

### isEmpty

    protected static final boolean isEmpty(Resource[][] r)

  Returns:
    true if all individual arrays are empty
  Since:
    Ant 1.5.2

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2003 Apache Software Foundation. All Rights Reserved.